/*
 * file CqUserDbMember.java
 *
 * Licensed Materials - Property of IBM
 * Restricted Materials of IBM 
 *
 * com.ibm.rational.wvcm.stp.cq.CqUserDbMember
 *
 * (C) Copyright IBM Corporation 2004, 2008.  All Rights Reserved.
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or 
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.rational.wvcm.stp.cq;

import static com.ibm.rational.wvcm.stpex.StpExBase.PROPERTY_NAMESPACE;

import javax.wvcm.WvcmException;
import javax.wvcm.PropertyNameList.PropertyName;

import com.ibm.rational.wvcm.stpex.StpExBase;

/**
 * The properties supported by all members of a ClearQuest User Database.
 */
public interface CqUserDbMember extends CqResource {
    /** The user database that contains this resource. */
    PropertyName<CqUserDb> USER_DB =
        new PropertyName<CqUserDb>(PROPERTY_NAMESPACE,
                                   "user-db");

    /**
     * Returns the value of the {@link #USER_DB USER_DB} property as defined by 
     * this proxy.
     *
     * @return  A CqUserDb proxy for the database that contains this resource
     *
     * @throws  WvcmException  if this proxy does not define a value for the
     *                         {@link #USER_DB USER_DB} property.
     */
    CqUserDb getUserDb() throws WvcmException;

    /** The database set that contains this resource */
    PropertyName<CqDbSet> DB_SET = 
        new PropertyName<CqDbSet>(PROPERTY_NAMESPACE, "db-set");

    /**
     * Returns the value of the {@link #DB_SET DB_SET} property as defined by 
     * this proxy.
     *
     * @return  A CqDbSet proxy for the database set that contains this resource.
     *
     * @throws  WvcmException  if this proxy does not define a value for the
     *                         {@link #DB_SET DB_SET} property.
     */
    CqDbSet getDbSet() throws WvcmException;
}
